package spiel;

public class Conway{

    private boolean[][] zellen;
    private int groesse=0;
    private Interaktionsbrett ib;

    public void starten(){
        while(this.groesse<1){
            System.out.println("Feldgroesse n (>0): ");
            this.groesse = Eingabe.leseInt();
        }
        zellen = new boolean[this.groesse][this.groesse];
        int w = -1;
        while(w<0){
            System.out.println("Wahrscheinlichkeit w (0-100): ");
            w = Eingabe.leseInt();
        }
        for(int i=0; i<this.groesse; i=i+1){
            for(int j=0; j<this.groesse; j=j+1){
                if(Math.random()*100 < w){
                    this.zellen[i][j] = true;
                } else {
                    this.zellen[i][j] = false;
                }
            }
        }
        this.ib = new Interaktionsbrett();
        this.visualisieren();
    }

    public void visualisieren(){
        int pix=10;
        this.ib.abwischen();
        for(int i=0; i<this.groesse; i=i+1){
            for(int j=0; j<this.groesse; j=j+1){
                this.ib.neuesRechteck(5+i*pix,5+j*pix,pix,pix);
                if(this.zellen[i][j]){
                    for(int k = 0; k<pix; k=k+1){
                        ib.neueLinie(5+i*pix,5+j*pix+k,5+pix+i*pix,5+pix*j+k);
                    }
                }
            }
        }
    }

    public void simulieren(){
        int schritte = 1;
        while(schritte >0){
            System.out.println("Anzahl Schritte (>0): ");
            schritte = Eingabe.leseInt();
            if(schritte>0){
                for(int i=0; i<schritte; i=i+1){
                    schritt();
                }
                this.visualisieren();
            }
        }   
    }

    public void schritt(){
        boolean[][] ergebnis= new boolean [this.groesse][this.groesse];
        for(int i=0;i<this.groesse;i=i+1){
            for(int j=0;j<this.groesse ;j=j+1){
                int bewohner=0;
                for(int a=i-1;a<=i+1;a++){
                    for(int b=j-1;b<=j+1;b++){
                        if(a>=0 && a<this.groesse && b>=0 
                                && b<this.groesse && (a!=i || b!=j) 
                                && zellen[a][b]){
                            bewohner = bewohner+1;
                        }
                    }
                }
                ergebnis[i][j]=(((bewohner==2 || bewohner==3)&& zellen[i][j])
                    || bewohner==3);
            }
        }
        this.zellen = ergebnis;
    }
    
    public static void main(String[] args) {
        Conway c = new Conway();
        c.starten();
        c.simulieren();
    }

    public boolean[][] getZellen() {
        return zellen;
    }

    public void setZellen(boolean[][] zellen) {
        this.zellen = zellen;
    }

    public int getGroesse() {
        return groesse;
    }

    public void setGroesse(int groesse) {
        this.groesse = groesse;
    }
}

